// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Droit calculé pour un utilisateur à partir d'autres entités
 * implémentant la gestion des droits. S’applique pour un type de
 * donnée, sur une période donnée.
 * </p>
 * <p>
 * Créé d'après l'étude sur l'amélioration des performances V3 (cf.
 * mantis 10528).
 * </p>
 */
public abstract class PersonSessionVessel
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 7904363713448482514L;

    private java.lang.Long id;

    /**
     * <p>
     * Identifiant technique
     * </p>
     */
    public java.lang.Long getId()
    {
        return this.id;
    }

    public void setId(java.lang.Long id)
    {
        this.id = id;
    }

    private java.lang.Boolean readVessel = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * indique le droit de consulter le droit de voir le navire dans
     * l’application cliente (toujours à ‘TRUE’ en v3.2
     * </p>
     */
    public java.lang.Boolean getReadVessel()
    {
        return this.readVessel;
    }

    public void setReadVessel(java.lang.Boolean readVessel)
    {
        this.readVessel = readVessel;
    }

    private java.lang.Boolean readData;

    /**
     * <p>
     * indique le droit de consulter les données de type ObjectType en
     * lecture
     * </p>
     */
    public java.lang.Boolean getReadData()
    {
        return this.readData;
    }

    public void setReadData(java.lang.Boolean readData)
    {
        this.readData = readData;
    }

    private java.lang.Boolean writeData;

    /**
     * <p>
     * indique le droit de modifier et d’exporter les données de type
     * ObjectType
     * </p>
     */
    public java.lang.Boolean getWriteData()
    {
        return this.writeData;
    }

    public void setWriteData(java.lang.Boolean writeData)
    {
        this.writeData = writeData;
    }

    private java.lang.Boolean validateData;

    /**
     * <p>
     * Indique que l'utilisateur lié à PersonSession à le droit de
     * validation sur les données de type ObjectType, sur la période
     * indiquée et pour le navire et le programme liés.
     * </p>
     */
    public java.lang.Boolean getValidateData()
    {
        return this.validateData;
    }

    public void setValidateData(java.lang.Boolean validateData)
    {
        this.validateData = validateData;
    }

    private java.sql.Timestamp startDateTime;

    /**
     * <p>
     * date de début de période d’application du droit calculé
     * </p>
     */
    public java.sql.Timestamp getStartDateTime()
    {
        return this.startDateTime;
    }

    public void setStartDateTime(java.sql.Timestamp startDateTime)
    {
        this.startDateTime = startDateTime;
    }

    private java.sql.Timestamp endDateTime;

    /**
     * <p>
     * date de fin d’application du droit calculé. Attribut obligatoire
     * : lorsque la valeur n'est pas renseignée dans les portefeuilles
     * on lui assigne une valeur par défaut supérieure à toute autre
     * date.
     * </p>
     */
    public java.sql.Timestamp getEndDateTime()
    {
        return this.endDateTime;
    }

    public void setEndDateTime(java.sql.Timestamp endDateTime)
    {
        this.endDateTime = endDateTime;
    }

    private java.sql.Timestamp updateDate;

    /**
     * <p>
     * Date de dernière modification en base centrale : utilisé pour la
     * synchronisation entre base locale et base distante
     * </p>
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel;

    /**
     * <p>
     * navire pour lequel s’applique ce droit
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getVessel()
    {
        return this.vessel;
    }

    public void setVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
    {
        this.vessel = vessel;
    }


    private fr.ifremer.adagio.core.dao.administration.user.PersonSession personSession;

    /**
     * <p>
     * lien vers la tête de grappe (qui porte elle-même le lien vers
     * l’utilisateur pour lequel s’applique le droit calculé)
     * </p>
     */
    public fr.ifremer.adagio.core.dao.administration.user.PersonSession getPersonSession()
    {
        return this.personSession;
    }

    public void setPersonSession(fr.ifremer.adagio.core.dao.administration.user.PersonSession personSession)
    {
        this.personSession = personSession;
    }


    private fr.ifremer.adagio.core.dao.administration.programStrategy.Program program;

    /**
     * <p>
     * programme pour lequel s’applique ce droit
     * </p>
     */
    public fr.ifremer.adagio.core.dao.administration.programStrategy.Program getProgram()
    {
        return this.program;
    }

    public void setProgram(fr.ifremer.adagio.core.dao.administration.programStrategy.Program program)
    {
        this.program = program;
    }


    private fr.ifremer.adagio.core.dao.referential.ObjectType objectType;

    /**
     * <p>
     * type de donnée sur lequel porte ce droit
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.ObjectType getObjectType()
    {
        return this.objectType;
    }

    public void setObjectType(fr.ifremer.adagio.core.dao.referential.ObjectType objectType)
    {
        this.objectType = objectType;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof PersonSessionVessel))
        {
            return false;
        }
        final PersonSessionVessel that = (PersonSessionVessel)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel}.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel newInstance()
        {
            final fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel entity = new fr.ifremer.adagio.core.dao.administration.user.PersonSessionVesselImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel newInstance(java.lang.Boolean readVessel, java.lang.Boolean readData, java.lang.Boolean writeData, java.sql.Timestamp startDateTime, java.sql.Timestamp endDateTime, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.user.PersonSession personSession, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.referential.ObjectType objectType)
        {
            final fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel entity = newInstance();
            entity.setReadVessel(readVessel);
            entity.setReadData(readData);
            entity.setWriteData(writeData);
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setUpdateDate(updateDate);
            entity.setVessel(vessel);
            entity.setPersonSession(personSession);
            entity.setProgram(program);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel newInstance(java.lang.Boolean readVessel, java.lang.Boolean readData, java.lang.Boolean writeData, java.lang.Boolean validateData, java.sql.Timestamp startDateTime, java.sql.Timestamp endDateTime, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.user.PersonSession personSession, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.referential.ObjectType objectType)
        {
            final fr.ifremer.adagio.core.dao.administration.user.PersonSessionVessel entity = newInstance();
            entity.setReadVessel(readVessel);
            entity.setReadData(readData);
            entity.setWriteData(writeData);
            entity.setValidateData(validateData);
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setUpdateDate(updateDate);
            entity.setVessel(vessel);
            entity.setPersonSession(personSession);
            entity.setProgram(program);
            entity.setObjectType(objectType);
            return entity;
        }
    }
    
// PersonSessionVessel.java merge-point
}