// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.taxon;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Type de groupe de taxon.
 * </p>
 * <p>
 * On distingue plusieurs types de regroupements de taxons :
 * </p>
 * <p>
 * - les groupes descriptifs des taxons, et utilisés à l'extraction
 * des données (groupes écologiques par exemple)
 * </p>
 * <p>
 * - les groupes utilisés pour l'identification sur les navires de
 * pêche ou dans les criées : espèce commerciale, ou espèce
 * communes (nom vernaculaire)
 * </p>
 * <p>
 * -  ...
 * </p>
 */
public abstract class TaxonGroupType
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6658880623947843642L;

    private java.lang.String code;

    /**
     * <p>
     * Code unique du groupe de taxons.
     * </p>
     */
    public java.lang.String getCode()
    {
        return this.code;
    }

    public void setCode(java.lang.String code)
    {
        this.code = code;
    }

    private java.lang.String name;

    /**
     * <p>
     * Libellé (court) décrivant le type de groupe de taxon.
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup> taxonGroups = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup> getTaxonGroups()
    {
        return this.taxonGroups;
    }

    public void setTaxonGroups(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup> taxonGroups)
    {
        this.taxonGroups = taxonGroups;
    }


    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonGroupType))
        {
            return false;
        }
        final TaxonGroupType that = (TaxonGroupType)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (code == null ? 0 : code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType}.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType entity = new fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupTypeImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType newInstance(java.lang.String name)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType entity = newInstance();
            entity.setName(name);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType newInstance(java.lang.String name, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup> taxonGroups)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroupType entity = newInstance();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setTaxonGroups(taxonGroups);
            return entity;
        }
    }
    
// TaxonGroupType.java merge-point
}